﻿using System.ComponentModel;
using System.Windows;

namespace TestXamDataGrid
{
    public enum EditingMode
    {
        None,
        Add,
        Edit,
        Load
    }

    public abstract class BaseInfo : DependencyObject, INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region OnPropertyChanged
        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));

        }
        #endregion //OnPropertyChanged
    }
}
