﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace TestXamDataGrid
{
    /// <summary>
    /// Interaction logic for BookEditor.xaml
    /// </summary>
    public partial class BookEditor : Window
    {
        ViewModel MyViewModel;
        XamDataGrid MyDataGrid;

        public BookEditor(ViewModel ViewModelToUse, XamDataGrid DataGridToUse )
        {
            InitializeComponent();
            MyViewModel = ViewModelToUse;
            MyDataGrid = DataGridToUse;
            this.DataContext = MyViewModel;
        }

        private void NextBook_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            if (DataPresenterCommands.RecordBelow.CanExecute(null, MyDataGrid)) e.CanExecute = true;
            else e.CanExecute = false;
        }

        private void NextBook_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            MyDataGrid.ExecuteCommand(DataPresenterCommands.RecordBelow);
        }

        private void PreviousBook_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            if (DataPresenterCommands.RecordAbove.CanExecute(null, MyDataGrid)) e.CanExecute = true;
            else e.CanExecute = false;
        }

        private void PreviousBook_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            MyDataGrid.ExecuteCommand(DataPresenterCommands.RecordAbove);
        }

    }
}
