﻿using System;
using System.ComponentModel;
using System.Collections.Generic;

namespace TestXamDataGrid
{
    public partial class BookInfo : BaseInfo, IDataErrorInfo
    {
        #region Properties

        #region Id
        private string _id;
        [DataObjectField(true)]
        public string Id
        {
            get { return _id; }
            set
            {
                _id = value;
                OnPropertyChanged("Id");
            }

        }
        #endregion //Id

        #region ISBN
        private string _ISBN;
        [DataObjectField(false)]
        public string ISBN
        {
            get { return _ISBN; }
            set
            {
                _ISBN = value;
                OnPropertyChanged("ISBN");
            }

        }
        #endregion //ISBN

        #region Title
        private string _Title;
        [DataObjectField(false)]
        public string Title
        {
            get { return _Title; }
            set
            {
                _Title = value;
                OnPropertyChanged("Title");
            }

        }
        #endregion //Title

        #region Series
        private string _Series;
        [DataObjectField(false)]
        public string Series
        {
            get { return _Series; }
            set
            {
                _Series = value;
                OnPropertyChanged("Series");
            }
        }
        #endregion //Series

        #region Author
        private string _Author;
        [DataObjectField(false)]
        public string Author
        {
            get { return _Author; }
            set
            {
                _Author = value;
                OnPropertyChanged("Author");
            }
        }
        #endregion //Author

        #region Publisher
        private string _Publisher;
        [DataObjectField(false)]
        public string Publisher
        {
            get { return _Publisher; }
            set
            {
                _Publisher = value;
                OnPropertyChanged("Publisher");
            }
        }
        #endregion //Publisher

        #region PrintDate
        private String _PrintDate;
        [DataObjectField(false)]
        public String PrintDate
        {
            get { return _PrintDate; }
            set
            {
                _PrintDate = value;
                OnPropertyChanged("PrintDate");
            }
        }
        #endregion //PrintDate

        #region Copyright
        private String _Copyright;
        [DataObjectField(false)]
        public String Copyright
        {
            get { return _Copyright; }
            set
            {
                _Copyright = value;
                OnPropertyChanged("Copyright");
            }
        }
        #endregion //Copyright

        #region GradeLevel
        private string _GradeLevel;
        [DataObjectField(false)]
        public string GradeLevel
        {
            get { return _GradeLevel; }
            set
            {
                _GradeLevel = value;
                OnPropertyChanged("GradeLevel");
            }
        }
        #endregion //GradeLevel

        #region Rating
        private string _Rating;
        [DataObjectField(false)]
        public string Rating
        {
            get { return _Rating; }
            set
            {
                _Rating = value;
                OnPropertyChanged("Rating");
            }
        }
        #endregion //Rating

        #region Status
        private string _Status;
        [DataObjectField(false)]
        public string Status
        {
            get { return _Status; }
            set
            {
                _Status = value;
                OnPropertyChanged("Status");
            }
        }
        #endregion //Status

        #region StatusDate
        private String _StatusDate;
        [DataObjectField(false)]
        public String StatusDate
        {
            get { return _StatusDate; }
            set
            {
                _StatusDate = value;
                OnPropertyChanged("StatusDate");
            }
        }
        #endregion //StatusDate

        #region Notes
        private string _Notes;
        [DataObjectField(false)]
        public string Notes
        {
            get { return _Notes; }
            set
            {
                _Notes = value;
                OnPropertyChanged("Notes");
            }
        }
        #endregion //Notes

        #region IsAtCedarRun
        private bool _IsAtCedarRun;
        [DataObjectField(false)]
        public bool IsAtCedarRun
        {
            get { return _IsAtCedarRun; }
            set
            {
                _IsAtCedarRun = value;
                OnPropertyChanged("IsAtCedarRun");
            }
        }
        #endregion //IsAtCedarRun

        #region IsAtHamlin
        private bool _IsAtHamlin;
        [DataObjectField(false)]
        public bool IsAtHamlin
        {
            get { return _IsAtHamlin; }
            set
            {
                _IsAtHamlin = value;
                OnPropertyChanged("IsAtHamlin");
            }
        }
        #endregion //IsAtHamlin

        #region IsAtHegins
        private bool _IsAtHegins;
        [DataObjectField(false)]
        public bool IsAtHegins
        {
            get { return _IsAtHegins; }
            set
            {
                _IsAtHegins = value;
                OnPropertyChanged("IsAtHegins");
            }
        }
        #endregion //IsAtHegins


        #endregion //Properties

        #region IDataErrorInfo Members

        public string Error
        {
            get 
            { 
                //TODO need to implement list of current errors.
                if (string.IsNullOrWhiteSpace(_Title)) return "Title is required";
                else return null;
                //throw new NotImplementedException();
            }
        }

        public string this[string PropertyName]
        {
            get
            {
                if (PropertyName == "Title")
                {
                    if (string.IsNullOrWhiteSpace(Title))
                        return "Please enter a Title.";
                }
                return null;
            }
        }

        #endregion
    }
}
