﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Threading;

namespace TestXamDataGrid
{
    /// <summary>
    /// Interaction logic for LogIn.xaml
    /// </summary>
    public partial class LogIn : Window
    {
        LoadingStatusScreen MySplashScreen;
        public delegate void UpdateDelegate(int Percentage, String Message);
        public delegate void CloseMeDelegate();
        
        public LogIn()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            MySplashScreen = new LoadingStatusScreen(0, "Initializing");
            MySplashScreen.Show();
            UpdateLayout();

            Thread LoadMainProgram = new Thread(new ThreadStart(() => LaunchMainWindow()));
            LoadMainProgram.SetApartmentState(ApartmentState.STA);
            LoadMainProgram.IsBackground = true;
            LoadMainProgram.Start();
            this.ShowInTaskbar = false;
            this.Visibility = System.Windows.Visibility.Hidden;
        }

        void SendUpdateToSplashScreen(int Percentage, String Message)
        {
            MySplashScreen.UpdateStatus(Percentage, Message);
        }

        private void LaunchMainWindow()
        {
            UpdateDelegate MyUpdateDelegate = new UpdateDelegate(SendUpdateToSplashScreen);
            this.Dispatcher.BeginInvoke(MyUpdateDelegate, new object[] { 5, "Initializing" });

            this.Dispatcher.BeginInvoke(MyUpdateDelegate, new object[] { 60, "Connecting to Database" });
            ViewModel MyViewModel = new ViewModel();
            
            this.Dispatcher.BeginInvoke(MyUpdateDelegate, new object[] { 90, "Loading Main Window" });
            Window MainWindow = new MainWindow(MyViewModel);
            MainWindow.Closed += (sender1, e1) => MainWindow.Dispatcher.InvokeShutdown();
            MainWindow.Show();

            this.Dispatcher.BeginInvoke(MyUpdateDelegate, new object[] { 100, "Finished Loading" });
            SendUpdateToSplashScreen(100, "Finished Loading");
            System.Windows.Threading.Dispatcher.Run();

            this.Dispatcher.BeginInvoke(new CloseMeDelegate(CloseWindow), null);
        }

        private void CloseWindow()
        {
            this.Close();
        }
    }
}
