﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using Infragistics.Windows.Reporting;

namespace TestXamDataGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel MyViewModel;
        
        public MainWindow(ViewModel ViewModelToUse)
        {
            InitializeComponent();
            MyViewModel = ViewModelToUse;
            this.DataContext = MyViewModel;
        }

        private void xamDataGrid1_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            CellValuePresenter cvp = Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject, typeof(CellValuePresenter), false) as CellValuePresenter;
            if (cvp != null)
            {
                LaunchBookEditor();
            } 
        }

        private void LaunchBookEditor()
        {
            BookEditor MyBookEditor = new BookEditor(MyViewModel, xamDataGrid1);
            MyBookEditor.Owner = Window.GetWindow(this);
            MyBookEditor.ShowDialog();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {

            /// <summary>
            /// This method shows how to print XamDataGrid1 in printer
            /// </summary>
            /// <param name="sender"></param>
            /// <param name="e"></param>
            // 1. Create Report object
            Report reportObj = new Report();
            reportObj.ReportSettings.Margin = new Thickness(30, 20, 25, 20);
            reportObj.ReportSettings.RepeatType = RepeatType.PageBreak;

            // 2. Create EmbeddedVisualReportSection section. 
            // Put the grid you want to print as a parameter of section's constructor
            EmbeddedVisualReportSection section = new EmbeddedVisualReportSection(xamDataGrid1);


            // 3. Add created section to report's section collection
            reportObj.Sections.Add(section);

            // Optional. If you have progress indicator set its Report property to created report
            //progressInfo.Report = reportObj;

            // 4. Call print method
            if (reportObj.ShowPrintDialog())
            {
                reportObj.ReportSettings.PrintQueue.CurrentJobSettings.Description = "Library Books List " + DateTime.Now.Date.ToShortDateString().Replace("/", "-");
                reportObj.Print(true, true, xamDataGrid1);
            }
        }
    }
}
